# 170823 - BASED ON denoise_v5.R

setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta HAPLOTYPING/2 JAMP DceM/R_alpha_values!")

library("seqinr")


if(F){
# GENERATE REFERENCE HAPLO FASTA FAILE (already done p.719)
DNA <- read.fasta("140418_xBlastDB_v3.fasta", as.string=T, forceDNAtolower=F)
DNA <- unlist(DNA)
DNA <- substr(DNA, 271, 448) # only fwh1 regoin

# 15 uniqe haplotypes

uniqueDNA <- unique(DNA)
IDs <- names(DNA)

match(DNA, uniqueDNA)

# get weights
weight <- read.csv("DceM_suple.csv", stringsAsFactors=F)

data <- data.frame(IDs, "same"=match(DNA, uniqueDNA), stringsAsFactors=F, "weight"=weight$mean, "DNA"= DNA)


temp <- aggregate(data$weight, by=list(data$same), "sum")

table(data$same)

temp2 <- cbind(temp, uniqueDNA)

cat(file="161226_fwh1_DceM+.txt", paste(">", temp2$Group.1, "_", temp2$x, "\n", temp2$uniqueDNA, sep=""), sep="\n")
}


# use PLOT SCRIPT from other file (max ee test)!

# make fasta files!
files <- list.files("_haplo_tables", ".csv", full.names=T)
i <- 7

for ( i in 1:length(files)){

alpha_value <- sub(".*alpha_(.*)_.*_.*", "\\1", files[i])

temp <- read.csv(files[i], stringsAsFactors=F)
write.fasta(as.list(temp$sequences[-nrow(temp)]), temp$haplotype[-nrow(temp)], paste("1_fasta_to_compare_against/fasta_DceM_alpha_", alpha_value, ".txt", sep=""))

system2("vsearch", paste("-usearch_global 1_fasta_to_compare_against/fasta_DceM_alpha_", alpha_value, ".txt -db 161226_fwh1_DceM.txt -blast6out 2_matches/DceM_alpha_", alpha_value, ".txt -strand plus -id 0.97", sep=""))

# make table

hits <- read.csv(paste("2_matches/DceM_alpha_", alpha_value, ".txt", sep=""), stringsAsFactors=F, sep="\t", header=F)
temp <- read.csv(paste("_haplo_tables/haplotable_alpha_", alpha_value, "_haplosize_0.csv", sep=""), stringsAsFactors=F)

nrow(hits)
nrow(temp)

#head(hits)
#head(temp)

data2 <- merge(hits, temp, by.x="V1", by.y="haplotype")
data <- data2[-17]


data <- data.frame(data, "color"="Gray", "mg"=sub(".*_", "", data$V2), stringsAsFactors=F)
data $color[data$V3==100 & data$V4==178 & data$V7==1 & data$V8==178] <- "Black"
data <- data[-c(3:12)]

names(data)[c(5,6)] <- c("A", "B")

data <- data.frame(data, "abund_A"=data$A/1000000*100, "abund_B"=data$B/1000000*100)

data$abund_A[data$abund_A<0.003] <- NA
data$abund_B[data$abund_B<0.003] <- NA

data$A[is.na(data$abund_A)] <- NA
data$B[is.na(data$abund_B)] <- NA

data <- data[order(data$sort),]

data <- data.frame(data, "mean"=rowMeans(data[9:10]))


data$mean[is.na(data$abund_A)] <- data$abund_B[is.na(data$abund_A)]

data$mean[is.na(data$abund_B)] <- data$abund_A[is.na(data$abund_B)] 

data <- data[!is.na(data$mean),]


sd <- NULL
for (i in 1:nrow(data)){
sd[i] <-sd(c(data$abund_A[i], data$abund_B[i]))
}

data <- data.frame(data, sd)


write.csv(data, paste("3_tables/DceM_alpha_", alpha_value, ".csv", sep=""))

}





