# 170823 - BASED ON denoise_v5.R

setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta HAPLOTYPING/2 JAMP DceM/R_alpha_values!")

library("seqinr")

files <- list.files("3_tables", full.names=T)


# MAKE PLOT SCRIPT

file <- "1_tables/DceM__ee0.02_noDenoise.csv"


my_plot <- function(file=NA, names=F){

data <- read.csv(file, stringsAsFactors=F)

print(head(data, 30))

lm <- lm(log10(data$mean[data$color=="Black"]) ~log10(data$mg[data$color=="Black"]))
summary <- summary(lm)
print(summary)


pdf(sub(".csv", ".pdf", file), height=6, width=4, useDingbats=F)
plot(0.0001, log="xy", ylim=c(0.003, 100), xaxt="n", yaxt="n", ylab="relative abundance", xlab="specimen weight in mg", xlim=c(0.1, 500))



# get point types!

if(!is.null(data$sd)){
i <- 1
for(i in 1:nrow(data)){
lines(c(data$mg[i], data$mg[i]), c(data$mean[i]-data$sd[i], data$mean[i]+data$sd[i]), col=data$color[i])
}

type <- rep(1, 1, nrow(data))
type[is.na(data$A)] <- "B"
type[is.na(data$B)] <- "A"

data$color[is.na(data$A)] <- "deepskyblue"
data$color[is.na(data$B)] <- "blue"



points(data$mg[!is.na(data$sd)], data$mean[!is.na(data$sd)], col=data$color[!is.na(data$sd)], pch=1)

points(data$mg[is.na(data$sd)], data$mean[is.na(data$sd)], col= data$color[is.na(data$sd)], pch=type[is.na(data$sd)], cex=0.8)
abline(lm, col="red")
} else { # without replicates (pooled)
points(data$mg, data$mean, col=data$color, pch=1)
abline(lm, col="red")
}


axis(2, at=c(0.003, 0.01, 0.1, 1, 10, 100), labels=c("0.003", "0.01", "0.1", "1", "10", "100"), las=1)
axis(1, at=c(0.1, 1, 10, 100), labels=c(0.1, 1, 10, 100), las=1)

if(names){
text(data$mg[data$color=="Black"], data$mean[data$color=="Black"]*1.2, data$mgorig[data $color=="Black"], col="Darkgreen", cex=0.5)
}
p <- round(summary$coefficients[,4][2], 4)
if (p < 0.001){p <- "< 0.001"} else {p <- paste("","=",round(p, 3))}
text <- paste(sum(data$color=="Black"), " + ", sum(data$color=="Gray"), " + ", sum(data$color=="blue"), " + ", sum(data$color=="deepskyblue"), "\nR2 = ", round(unlist(summary[9]), 3), "\np ", p, sep="")
text(0.09, 120, text, adj=c(0,1))

dev.off()
message("plot_done!")
}


for(i in 1:9){
my_plot(files[i])
}

