# 170806 finland map generation

setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta HAPLOTYPING/2 JAMP finland/r maps")

library("RColorBrewer")
library("png")
library("pegas")
#library("JAMP")

files <- "2 selected MAPS/3_Oulimnius_tuberculatus/BF1+BR1_Oulimnius_v1.csv"


files <- "2 selected MAPS/2_Hydropsche_pellucidula/BF1+BR1_Hydropsyche_v1.csv"




plot_me <- function(files, keep){
mysize <- NULL
table <- read.csv(files, stringsAsFactors=F)
# 5% cut of haplotypes!
temp <- table

for(i in 4:39){
if(sum(sum(table[,i]))>0){
rm <- !table[,i]/sum(table[,i])*100 >= 5
table[rm, i] <- 0
table[,i] <- table[,i]/sum(table[,i])*100}
}

# remove sequences below %tag cutoff
table <- table[rowSums(table[4:39])!=0,]
table <- table[order(rowSums(table[4:39]), decreasing=T),]

# make haplonetwork

network_name <- sub(".csv", "_network_AB.pdf", files)

cat(paste(paste(">", table$haplotype, "\n", sep=""), table$sequences, collapse="\n", sep=""), file=sub("_AB.pdf", "_haplotypes.fasta", network_name), sep="")

#### make haplotype networks
#install.packages("pegas")
#library("pegas")

temp <- table
head(temp)
if(nrow(temp)>2){
x <- as.list(temp$sequ)
names(x) <- temp$haplotype

x <- as.DNAbin(as.alignment(x))
h <- haplotype(x, labels=temp$haplotype)
net <- haploNet(h)

net[,3] <- net[,3] #-1
#print.default(net)

#mysize <- rowSums(temp[5:24], na.rm=T)/sum(temp[5:24], na.rm=T)*100
mysize <- rowSums(temp>0, na.rm=T)

pdf(network_name, width=10, height=10)
plot(net, size= mysize, scale.ratio = 10, cex = 0.5, show.mutation=0)
dev.off()

pdf(sub(".pdf", "_num.pdf", network_name), width=10, height=10)
plot(net, size= mysize, scale.ratio = 10, cex = 0.5, show.mutation=3)
dev.off()

}

if(is.null(mysize)){
mysize <- rep(1, nrow(table))
}
# make haplotype maps
table <- cbind(table, mysize)

table <- table[order(mysize, decreasing=T),]

cbind(table$haplotype, rowSums(table[4:39]), table$mysize)



my_palette <- brewer.pal(9,"Set1")
my_palette <- c(my_palette, "lightskyblue", rep("white", 30))
# network end!

meeeeep <- data.frame(table[,2:3],"A"=rowSums(table[,4:22]), "B"=rowSums(table[,23:39]), my_palette[1:nrow(table)])
write.csv(meeeeep, file=sub(".csv", "_shared.csv", files))


# prepare files
keepA <- table[1:21]
keepB <- table[c(1:3, 22:39)]

keep_both <- table[1:3]

for (i in 1:18){
keep_both <- cbind(keep_both, c(table[i+3] + table[i+21]))
}

#library(RColorBrewer)
#library(png)
#install.packages("png")

name_MAP_imp <- sub(".csv", "_map", files)


map <- read.csv("Tab_gps.csv", stringsAsFactors=F)

ima <- readPNG("map_finland.png")

# INTERNA FUNCTION
internal_plot <- function(temp, name_temp){

temp <- temp[-c(1:3)]

pdf(name_temp, width=12, height=14)

par(oma=c(0,0,0,0), mar=c(0,0,0,0))
plot(-1,-1, ylim=c(0,4), xlim=c(0, 2))

rasterImage(ima, xleft= -0.05, ybottom= -0.1, xright= 2.05, ytop= 4.1)
#points(map$S, map$N)
#text(map$S+0.001, map$N, map$No)


#k <- 6
#map$hori[k] <- 0.36
#map$vert[k] <- 0.75

for(k in 1:18){
if(sum(temp[,k])>0){
par(new=T, fig=c(map$hori[k], map$hori[k]+0.08, map$vert[k], map$vert[k]+0.08), oma=c(0,0,0,0), mar=c(0,0,0,0))
pie(temp[,k], col= my_palette, labels=NA)
}
}
dev.off()

}#internal function end


internal_plot(keepA, paste(name_MAP_imp, "_A.pdf", sep=""))
internal_plot(keepB, paste(name_MAP_imp, "_B.pdf", sep=""))
internal_plot(keep_both, paste(name_MAP_imp, "_both.pdf", sep=""))

# linear plot?
temp <-data.frame("A"=unlist(keepA[,-c(1:3)]), "B"=unlist(keepB[,-c(1:3)]))
temp <- temp[rowSums(temp)>0,]
temp <- data.frame(temp, "letter"=rep("both", nrow(temp)), stringsAsFactors=F)

temp$letter[temp$B==0] <- "A"
temp$letter[temp$A==0] <- "B"


lm <- lm(temp$A~temp$B)
summary <- summary(lm)
#print(summary)


pdf(paste(name_MAP_imp, "_linear.pdf", sep=""), height=6, width=6)
plot(NULL, xlim=c(0,100), ylim=c(0,100), xlab="Replicate B", ylab="Replicate A")

points(temp$B[temp$letter=="both"], temp$A[temp$letter=="both"])
points(temp$B[temp$letter=="A"], temp$A[temp$letter=="A"], pch="A", col="#41BAEB")
points(temp$B[temp$letter=="B"], temp$A[temp$letter=="B"], pch="B", col="#3953A4")
abline(lm, col="red")

p <- round(summary$coefficients[,4][2], 4)
if (p < 0.001){p <- "< 0.001"} else {p <- paste("","=",round(p, 3))}
text <- paste("R2 = ", round(unlist(summary[9]), 3), "\np ", p, sep="")
text(10, 100, text, adj=c(0,1))


dev.off()

return(unlist(summary[9]))


} #function end




A1 <- plot_me("2 selected MAPS/1_Taeniopteryx_nebulosa/BF1+BR1_Taeniopteryx_v1.csv")
A2 <- plot_me("2 selected MAPS/1_Taeniopteryx_nebulosa/BF1+BR2_Taeniopteryx_v1.csv")
A3 <- plot_me("2 selected MAPS/1_Taeniopteryx_nebulosa/BF2+BR1_Taeniopteryx_v1.csv")
A4 <- plot_me("2 selected MAPS/1_Taeniopteryx_nebulosa/BF2+BR2_Taeniopteryx_v1.csv")

B1 <- plot_me("2 selected MAPS/2_Hydropsche_pellucidula/BF1+BR1_Hydropsyche_v1.csv")
B2 <- plot_me("2 selected MAPS/2_Hydropsche_pellucidula/BF1+BR2_Hydropsyche_v1.csv")
B3 <- plot_me("2 selected MAPS/2_Hydropsche_pellucidula/BF2+BR1_Hydropsyche_v1.csv")
B4 <- plot_me("2 selected MAPS/2_Hydropsche_pellucidula/BF2+BR2_Hydropsyche_v1.csv")

C1 <- plot_me("2 selected MAPS/3_Oulimnius_tuberculatus/BF1+BR1_Oulimnius_v1.csv")
C2 <- plot_me("2 selected MAPS/3_Oulimnius_tuberculatus/BF1+BR2_Oulimnius_v1.csv")
C3 <- plot_me("2 selected MAPS/3_Oulimnius_tuberculatus/BF2+BR1_Oulimnius_v1.csv")
C4 <- plot_me("2 selected MAPS/3_Oulimnius_tuberculatus/BF2+BR2_Oulimnius_v1.csv")



D1 <- plot_me("2 selected MAPS/4_Asellus_aquaticus/BF1+BR1_asellus_v1.csv")
D2 <- plot_me("2 selected MAPS/4_Asellus_aquaticus/BF1+BR2_asellus_v1.csv")
D3 <- plot_me("2 selected MAPS/4_Asellus_aquaticus/BF2+BR1_asellus_v1.csv")
D4 <- plot_me("2 selected MAPS/4_Asellus_aquaticus/BF2+BR2_asellus_v1.csv")




rsquared <- c(A1, A2, A3, A4, B1, B2, B3, B4, C1, C2, C3, C4, D1, D2, D3, D4)

mean(rsquared)
sd(rsquared)



